
-- TODO: Accomodate item links in prelim whisper
-- TODO: Back button for fucked up bids
-- TODO: Quick bid
	
local ARP = LibStub("AceAddon-3.0"):NewAddon("ARP")

ARP.VERSION = "r8"

----------------------)
---Global Variables---)
----------------------)

-- Configurable
local rankMember = 4 -- lowest guild rank of Members
local rankMemberException = 2 -- exception to the above (in case you have an "officer alt" rank, if none, just set to -1)
local rankTrial = 5 -- guild rank of Trials

-- Lists
local memberMain = {}			-- {ID, name, points}
local memberOff = {}	
local trialMain = {}	
local trialOff = {}
local lootList = {}				-- {ID, item, count}
local assignList = {}			-- {ID, name}
local lootBtnList = {}			-- {ID, btn}
local assignBtnList = {}

local heroicLoot = {502, 509, 535, }	
local ilvlLoot = {503, 516, 528, 541, }

-- Bid Specifics
local item = nil
local itemCount = 1
local curNum = 1
local currentBidder = nil
local bidderIndex = nil
local topBidder = nil
local channel = "RAID"
local minBid
local bidCategory

-- Booleans
local bTestMode = false			-- Is test mode enabled?
local bBidding = false			-- Is user currently bidding an item?
local bMult = false				-- More than one of the same item?
local bLootListBuilt = false	-- Has the loot list been built?

-- Misc
local classColors = RAID_CLASS_COLORS
local selectedItem = nil
local selectedAssign = nil

--------------------)
---ACE3 Functions---)
--------------------)
function ARP:OnInitialize()
	local options = {
		name = "ARP",
		handler = ARP,
		type = "execute",
		type = "group",
		args = {
			toggle = {
				type = "execute",
				name = "Toggle Core",
				desc = "Shows/hides the main frame",
				func = function() if ARP.corePanel:IsShown() then ARP.corePanel:Hide() else ARP.corePanel:Show() end end
			},
			reset = {
				type = "execute",
				name = "Value Reset",
				desc = "Resets variables",
				func = function() ARP_Reset() end
			},
			list = {
				type = "execute",
				name = "Bid List",
				desc = "Displays list of bidders",
				func = function() if (item or bTestMode) then ARP_DisplayBidders() else print("You have not been assigned an item!") end end
			},
			bid = {
				type = "execute",
				name = "Start Bidding",
				desc = "Starts bidding for assigned item",
				func = function() if (item or bTestMode) then ARP_StartBid() else print("You have not been assigned an item!") end end
			},
			channel = {
				type = "select",
				name = "Channel Select",
				desc = "Channel in which to display bid information",
				values = {raid="Raid", guild="Guild"},
				set = function(info, val) channel = strupper(val) print("Output channel changed to "..channel) end,
				get = function(info) return channel end,
				style = "dropdown"
			},	
			test = {
				type = "execute",
				name = "Test Mode",
				desc = "Enables/Disables test mode",
				func = function() if (bTestMode) then bTestMode = false print("Test mode disabled") else bTestMode = true print("Test mode enabled") end if (ARP.mlPanel:IsShown()) then ARP.mlPanel:Hide() end end
			},		
		},
	}

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Angry Raid Points", options, {"arp"})
end

function ARP:OnEnable()
	
	local arpFrame = CreateFrame("Frame")
	arpFrame:RegisterEvent("CHAT_MSG_WHISPER")
	arpFrame:RegisterEvent("CHAT_MSG_BN_WHISPER")
	-- arpFrame:RegisterEvent("CHAT_MSG_GUILD")
	-- arpFrame:RegisterEvent("CHAT_MSG_RAID")
	-- arpFrame:RegisterEvent("CHAT_MSG_RAID_LEADER")
	arpFrame:RegisterEvent("CHAT_MSG_ADDON")
	arpFrame:RegisterEvent("LOOT_OPENED")
	RegisterAddonMessagePrefix("ARP_LOG")
	RegisterAddonMessagePrefix("ARP_ASSIGN")
	RegisterAddonMessagePrefix("ARP_ASSIGN_MULT")	
	RegisterAddonMessagePrefix("ARP_QUERY")
	RegisterAddonMessagePrefix("ARP_READY")
	
	arpFrame:SetScript("OnEvent", ARP_OnEvent)
	ARP_CreateCoreFrame()
	ARP_CreateMLPanel()
	
end

--------------------------)
---Core Panel Functions---)
--------------------------) 
function ARP_CopyLootLog()
	local lootLog = ARP.corePanel.lootLog.text
	local copyFrame = ARP.corePanel.lootLog.copyFrame
	for i=lootLog:GetNumMessages(), 1, -1 do
		if ( i == lootLog:GetNumMessages() ) then
			copyFrame:Insert( lootLog:GetMessageInfo(i) )
		else copyFrame:Insert( "\n"..lootLog:GetMessageInfo(i) ) end
	end
	copyFrame:SetJustifyH("LEFT")
	copyFrame:Show()
	copyFrame:SetFocus()
	copyFrame:HighlightText(0)
	
	copyFrame:SetScript("OnEscapePressed", function(copyFrame)
		copyFrame:Hide()
	end)
	copyFrame:SetScript("OnEnterPressed", function(copyFrame)
		copyFrame:Hide()
	end)	
end

function ARP_CreateCoreFrame()
	local frame
	local button
	local title
	local text
	local dropdown
	local label	-- Predeclare variables to make future editing easier
	
	-- Core Panel
	frame = CreateFrame("Frame", "ARPCorePanel", UIParent)
	frame:SetSize(650, 650)
	frame:SetPoint("CENTER")
	frame:SetBackdrop( {	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
							edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = true,
							tileSize = 32,
							edgeSize = 24,
							insets = { left = 5, right = 6, top = 6, bottom = 5 } } )
	frame:EnableMouse(true)
	title = frame:CreateTitleRegion()
	title:SetAllPoints()
	frame:SetScript("OnShow", ARP_CorePanel_OnShow)
	frame:SetScript("OnUpdate", ARP_CorePanel_OnUpdate)
	tinsert(UISpecialFrames, "ARPCorePanel")
	frame:Hide()
	ARP.corePanel = frame
	
	-- Core Panel Title Texture
	local texture = ARP.corePanel:CreateTexture()
	texture:SetTexture("Interface\\Addons\\AngryRaidPoints\\Angry_Logo.tga")
	texture:SetPoint("TOP", ARP.corePanel, "TOP", -40, -5)
	
	label = ARP.corePanel:CreateFontString(nil, "OVERLAY")
	label:SetPoint("TOPLEFT", texture, "TOPRIGHT", -15, -55)
	label:SetJustifyH("LEFT")
	label:SetFont("Interface\\Addons\\AngryRaidPoints\\BlackChancery.ttf", 36, "OUTLINE")
	label:SetTextColor(1, 0.82, 0, 1)
	label:SetText("RP")
	
	label = ARP.corePanel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("BOTTOMLEFT", texture, "BOTTOMRIGHT", -15, 20)
	label:SetJustifyH("LEFT")
	label:SetText(ARP.VERSION)
	
	-- Assigned Item Label
	label = ARP.corePanel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("LEFT", ARP.corePanel, "LEFT", 25, 125)
	label:SetJustifyH("LEFT")
	label:SetText("ITEM")
	ARP.corePanel.itemLabel = label
	
	-- Assigned Item Text
	text = ARP.corePanel:CreateFontString(nil, "OVERLAY")
	text:SetPoint("LEFT", ARP.corePanel.itemLabel, "LEFT", 25, -30)
	text:SetJustifyH("LEFT")
	text:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
	ARP.corePanel.itemText = text
	
	-- Channel Output Label
	label = ARP.corePanel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("LEFT", ARP.corePanel, "LEFT", 25, 50)
	label:SetJustifyH("LEFT")
	label:SetText("CHANNEL OUTPUT")
	ARP.corePanel.channelLabel = label
	
	-- Channel Output Dropdown
	dropdown = CreateFrame("Frame", "ChannelOutputDropdown", ARP.corePanel, "UIDropDownMenuTemplate")
	dropdown:SetPoint("LEFT", ARP.corePanel.channelLabel, "LEFT", 0, -40)
	ARP.corePanel.channelDropdown = dropdown
	
	-- Current Bidder Label
	label = ARP.corePanel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("LEFT", ARP.corePanel, "LEFT", 25, -25)
	label:SetJustifyH("LEFT")
	label:SetText("CURRENT BIDDER")
	ARP.corePanel.curBidderLabel = label
	
	-- Current Bidder Text
	text = ARP.corePanel:CreateFontString(nil, "OVERLAY")
	text:SetPoint("LEFT", ARP.corePanel.curBidderLabel, "LEFT", 25, -30)
	text:SetJustifyH("LEFT")
	text:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
	ARP.corePanel.curBidderText = text
	
	-- Top Bidder Label
	label = ARP.corePanel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("LEFT", ARP.corePanel, "LEFT", 25, -100)
	label:SetJustifyH("LEFT")
	label:SetText("TOP BIDDER")
	ARP.corePanel.topBidderLabel = label
	
	-- Top Bidder Text
	text = ARP.corePanel:CreateFontString(nil, "OVERLAY")
	text:SetPoint("LEFT", ARP.corePanel.topBidderLabel, "LEFT", 25, -30)
	text:SetJustifyH("LEFT")
	text:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
	ARP.corePanel.topBidderText = text
	
	-- Core Frame Close Button
	button = CreateFrame("Button", "CoreCloseBtn", ARP.corePanel, "UIPanelButtonTemplate")
	button:SetSize(25, 25)
	button:SetPoint("TOPRIGHT", ARP.corePanel, "TOPRIGHT", -5, -6)
	button:SetText("X")
	button:SetScript("OnClick", function()
		ARP.corePanel:Hide()
	end)
	ARP.corePanel.closeBtn = button
	
	-- Core Frame Bid Button
	button = CreateFrame("Button", "CoreBidBtn", ARP.corePanel, "UIPanelButtonTemplate")
	button:SetSize(150, 30)
	button:SetPoint("BOTTOMLEFT", ARP.corePanel, "BOTTOMLEFT", 25, 25)
	button:SetText("Start Bid")
	button:Disable()
	button:SetScript("OnClick", function()
		ARP_StartBid()
	end)
	ARP.corePanel.bidBtn = button
	
	-- Core Frame Bid List Button
	button = CreateFrame("Button", "CoreBidListBtn", ARP.corePanel, "UIPanelButtonTemplate")
	button:SetSize(150, 30)
	button:SetPoint("BOTTOM", ARP.corePanel, "BOTTOM", 0, 25)
	button:SetText("Bid List")
	button:Disable()
	button:SetScript("OnClick", function()
		ARP_DisplayBidders()
	end)
	ARP.corePanel.listBtn = button
	
	-- Core Frame Reset Button
	button = CreateFrame("Button", "CoreResetBtn", ARP.corePanel, "UIPanelButtonTemplate")
	button:SetSize(150, 30)
	button:SetPoint("BOTTOMRIGHT", ARP.corePanel, "BOTTOMRIGHT", -25, 25)
	button:SetText("Reset")
	button:SetScript("OnClick", function()
		ARP_Reset()
	end)
	ARP.corePanel.resetBtn = button
	
	-- Loot Log Container
	frame = CreateFrame("Frame", "CoreLootLogContainer", ARP.corePanel)
	frame:SetSize(350, 200)
	frame:SetPoint("RIGHT", ARP.corePanel, "RIGHT", -50, -30)
	frame:SetBackdrop( {	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
							edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = true,
							tileSize = 32,
							edgeSize = 24,
							insets = { left = 5, right = 6, top = 6, bottom = 5 } } )
	ARP.corePanel.lootLog = frame
	
	-- Loot Log Label Text
	label = ARP.corePanel.lootLog:CreateFontString("LootLogLabel", "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("BOTTOM", ARP.corePanel.lootLog, "TOP")
	label:SetText("LOOT LOG")
	ARP.corePanel.lootLog.label = label
	
	-- Loot Log Message Box
	frame = CreateFrame("ScrollingMessageFrame", "LootLogText", ARP.corePanel.lootLog)
	frame:SetSize(320, 170)
	frame:SetPoint("TOPLEFT", ARP.corePanel.lootLog, "TOPLEFT", 8, -8)
	frame:SetJustifyH("LEFT")
	frame:SetFadeDuration(0)
	frame:SetFading(false)
	frame:SetInsertMode("TOP")
	frame:SetFontObject("ChatFontNormal")
	ARP.corePanel.lootLog.text = frame
	
	-- Loot Log Copy Container
	frame = CreateFrame("EditBox", "LootLogCopyFrame", ARP.corePanel.lootLog.text)
	frame:SetSize(300, 200)
	frame:SetAllPoints()
	frame:SetAutoFocus(false)
	frame:SetMultiLine(true)
	frame:SetFontObject("ChatFontNormal")	
	frame:Hide()
	ARP.corePanel.lootLog.copyFrame = frame
	
	-- Copy Loot Log Button
	button = CreateFrame("Button", "CopyLootLogBtn", ARP.corePanel.lootLog, "UIPanelButtonTemplate")
	button:SetSize(75, 30)
	button:SetPoint("CENTER", ARP.corePanel.lootLog, "BOTTOM", -75, -15)
	button:SetText("Copy")
	button:SetScript("OnClick", function()
		if (not ARP.corePanel.lootLog.copyFrame:IsShown()) then
			ARP_CopyLootLog()
		end
	end)
	ARP.corePanel.lootLog.copyBtn = button
	
	-- Clear Loot Log Button
	button = CreateFrame("Button", "ClearLootLogBtn", ARP.corePanel.lootLog, "UIPanelButtonTemplate")
	button:SetSize(75, 30)
	button:SetPoint("CENTER", ARP.corePanel.lootLog, "BOTTOM", 75, -15)
	button:SetText("Clear")
	button:SetScript("OnClick", function()
		ARP.corePanel.lootLog.text:Clear()
	end)
	ARP.corePanel.lootLog.clearBtn = button
	
	-- Core Frame Loot Assignment Button
	button = CreateFrame("Button", "CoreMLPanelShowBtn", ARP.corePanel, "UIPanelButtonTemplate")
	button:SetSize(150, 30)
	button:SetPoint("CENTER", ARP.corePanel.lootLog, "CENTER", 0, -175)
	button:SetText("Loot Assignment")
	button:Disable()
	button:SetScript("OnClick", function()
		if (ARP.mlPanel:IsShown()) then ARP.mlPanel:Hide()
		else ARP.mlPanel:Show() end
	end)
	ARP.corePanel.lootAssignBtn = button
	
end

function ARP_CorePanel_OnShow(self)
	SendAddonMessage("ARP_QUERY", nil, "GUILD")
	if (itemCount > 1) then	ARP.corePanel.itemText:SetText(item.."x"..itemCount)
	else ARP.corePanel.itemText:SetText(item) end
	ARP.corePanel.curBidderText:SetText(currentBidder)
	if (minBid ~= nil and topBidder ~= nil) then
		ARP.corePanel.topBidderText:SetText(topBidder) 
	end
	
	local function itemOnClick(self)
		local selected = self.value
		channel = selected
		UIDropDownMenu_SetSelectedValue(ARP.corePanel.channelDropdown, selected)
	end
	UIDropDownMenu_Initialize(ARP.corePanel.channelDropdown, function()
		local info = UIDropDownMenu_CreateInfo()
		local channels = {"RAID", "GUILD"}
		for i, chnl in next, channels do
			info.text = channels[i]
			info.value = chnl
			info.func = itemOnClick
			info.checked = chnl == channel
			UIDropDownMenu_AddButton(info)
		end
	end)
	UIDropDownMenu_SetSelectedValue(ARP.corePanel.channelDropdown, channel)
	UIDropDownMenu_SetWidth(ARP.corePanel.channelDropdown, 80)
	UIDropDownMenu_JustifyText(ARP.corePanel.channelDropdown, "LEFT")
	
	if (item or bTestMode) then
		ARP.corePanel.bidBtn:Enable()
		ARP.corePanel.listBtn:Enable()
	else 
		ARP.corePanel.bidBtn:Disable()
		ARP.corePanel.listBtn:Disable()
	end
	
	ARP.corePanel:SetScript("OnShow", nil)	
end

function ARP_CorePanel_OnUpdate(self, elapsed)
	if (itemCount > 1) then ARP.corePanel.itemText:SetText(item.."x"..itemCount)
	else ARP.corePanel.itemText:SetText(item) end
	
	UIDropDownMenu_SetSelectedValue(ARP.corePanel.channelDropdown, channel)
	
	if (currentBidder ~= nil) then
		if (UnitName("player") == currentBidder or UnitInRaid(currentBidder)) then
			local color = classColors[strupper(UnitClass(currentBidder))]
			ARP.corePanel.curBidderText:SetText("|c"..color.colorStr..currentBidder.."|r")
		else ARP.corePanel.curBidderText:SetText(currentBidder) end
	else ARP.corePanel.curBidderText:SetText(nil)
	end
	
	if (minBid ~= nil and topBidder ~= nil) then
		if (UnitName("player") == topBidder or UnitInRaid(topBidder)) then
			local color = classColors[strupper(UnitClass(topBidder))]
			ARP.corePanel.topBidderText:SetText("|c"..color.colorStr..topBidder.."|r at "..(minBid-1).." points")
		else ARP.corePanel.topBidderText:SetText(topBidder.." at "..(minBid-1).." points") end
	else ARP.corePanel.topBidderText:SetText(nil)
	end
	
	if (ARP.corePanel.lootLog.text:GetNumMessages() > 0) then
		ARP.corePanel.lootLog.copyBtn:Enable()
		ARP.corePanel.lootLog.clearBtn:Enable()
	else
		ARP.corePanel.lootLog.copyBtn:Disable()
		ARP.corePanel.lootLog.clearBtn:Disable()
	end
	
	if (item or bTestMode) then
		ARP.corePanel.bidBtn:Enable()
		ARP.corePanel.listBtn:Enable()
	else
		ARP.corePanel.bidBtn:Disable()
		ARP.corePanel.listBtn:Disable()
	end
	
	if (IsInRaid() and GetLootMethod() == "master") then
		local _, _, mlID = GetLootMethod()
		local mlName = GetRaidRosterInfo(mlID)
		if (mlName == UnitName("player") or bTestMode) then
			ARP.corePanel.lootAssignBtn:Enable()
		else ARP.corePanel.lootAssignBtn:Disable() end
	elseif (bTestMode) then
		ARP.corePanel.lootAssignBtn:Enable()
	else ARP.corePanel.lootAssignBtn:Disable()
	end
end

-----------------------------------)
---Master Looter Panel Functions---)
-----------------------------------)
function ARP_CreateMLPanel()
	local frame
	local button
	local label -- Predeclare variables to make future editing easier
	
	-- Master Looter Panel
	frame = CreateFrame("Frame", "MLPanel", ARP.corePanel)
	frame:SetSize(325, 500)
	frame:SetPoint("LEFT", ARP.corePanel, "RIGHT", -5, 0)
	frame:SetBackdrop( {	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
							edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = true,
							tileSize = 32,
							edgeSize = 24,
							insets = { left = 5, right = 6, top = 6, bottom = 5 } } )
	frame:EnableMouse(true)
	frame:SetScript("OnShow", ARP_MLPanel_Update)
	frame:Hide()
	ARP.mlPanel = frame
	
	-- Master Looter Panel Close Button
	button = CreateFrame("Button", "MLPanelCloseBtn", ARP.mlPanel, "UIPanelButtonTemplate")
	button:SetSize(25, 25)
	button:SetPoint("TOPRIGHT", ARP.mlPanel, "TOPRIGHT", -5, -6)
	button:SetText("X")
	button:SetScript("OnClick", function()
		ARP.mlPanel:Hide()
	end)
	ARP.mlPanel.closeBtn = button 
	
	-- Master Looter Panel Refresh Button
	button = CreateFrame("Button", "MLPanelRefreshBtn", ARP.mlPanel, "UIPanelButtonTemplate")
	button:SetSize(25, 25)
	button:SetPoint("TOPLEFT", ARP.mlPanel, "TOPLEFT", 5, -6)
	button:SetText("R")
	button:SetScript("OnClick", function()
		ARP_MLPanel_Update()
	end)
	ARP.mlPanel.refreshBtn = button	
	
	-- Master Looter Panel Loot Assignment Button
	button = CreateFrame("Button", "MLAssignBtn", ARP.mlPanel, "UIPanelButtonTemplate")
	button:SetSize(150, 30)
	button:SetPoint("BOTTOM", ARP.mlPanel, "BOTTOM", 0, 25)
	button:SetText("Assign")
	button:SetScript("OnClick", function()
		if (selectedItem and selectedAssign) then
			ARP_MLPanel_AssignLoot()
			ARP_MLPanel_Update()
		end
	end)
	ARP.mlPanel.assignBtn = button
	
	-- Maser Looter Panel Loot Clear Button
	button = CreateFrame("Button", "MLLootClearBtn", ARP.mlPanel, "UIPanelButtonTemplate")
	button:SetSize(75, 30)
	button:SetPoint("TOP", ARP.mlPanel, "TOP", 0, -215)
	button:SetText("Clear")
	button:SetScript("OnClick", function()
		ARP_MLPanel_ClearLoot()
	end)
	ARP.mlPanel.clearLootBtn = button
	
	-- Master Looter Panel Item List Container
	frame = CreateFrame("Frame", "MLItemList", ARP.mlPanel)
	frame:SetSize(250, 160)
	frame:SetPoint("TOP", ARP.mlPanel, "TOP", 0, -50)
	frame:SetBackdrop( {	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
							edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = true,
							tileSize = 32,
							edgeSize = 24,
							insets = { left = 5, right = 6, top = 6, bottom = 5 } } )
	ARP.mlPanel.itemList = frame
	
	-- Master Looter Panel Item List Label
	label = ARP.mlPanel.itemList:CreateFontString("ItemListLabel", "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("BOTTOM", ARP.mlPanel.itemList, "TOP")
	label:SetJustifyH("CENTER")
	label:SetText("ITEM LIST")
	ARP.mlPanel.itemList.label = label
	
	-- Master Looter Panel Assignment List
	frame = CreateFrame("Frame", "MLAssignList", ARP.mlPanel)
	frame:SetSize(250, 160)
	frame:SetPoint("BOTTOM", ARP.mlPanel, "BOTTOM", 0, 65)
	frame:SetBackdrop( {	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
							edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = true,
							tileSize = 32,
							edgeSize = 24,
							insets = { left = 5, right = 6, top = 6, bottom = 5 } } )
	ARP.mlPanel.assignList = frame
	
	-- Master Looter Panel Assignment List Label
	label = ARP.mlPanel.assignList:CreateFontString("AssignListLabel", "OVERLAY", "GameFontNormalLarge")
	label:SetPoint("BOTTOM", ARP.mlPanel.assignList, "TOP")
	label:SetJustifyH("CENTER")
	label:SetText("ASSIGN LIST")
	ARP.mlPanel.assignList.label = label	
end

function ARP_MLPanel_Update()
	for i,v in pairs(lootBtnList) do v["btn"]:Hide() end
	lootBtnList = {}
	for i=1, #lootList do
		local button = CreateFrame("CheckButton", "LootButton"..i, ARP.mlPanel.itemList, "UIRadioButtonTemplate")
		button.text = select(2, GetItemInfo(lootList[i]["item"]))
		button.count = lootList[i]["count"]
		local font = button:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		font:SetPoint("LEFT", button, "RIGHT", 5, 1)
		button:SetFontString(font)
		button:SetHitRectInsets(0, -225, 0, 0)
		if (lootList[i]["count"] > 1) then button:SetText(button.text.."x"..lootList[i]["count"])
		else button:SetText(button.text) end
		if (i > 1) then 
			button:SetPoint("TOPLEFT", ARP.mlPanel.itemList.prevBtn, "BOTTOMLEFT", 0, 0)
		else button:SetPoint("TOPLEFT", ARP.mlPanel.itemList, "TOPLEFT", 5, -5) end
		button:SetScript("OnClick", function(self, button, up)
			if (self:GetChecked()) then
				selectedItem = i
				ARP_MLPanel_SelectItem(i)
			else selectedItem = nil end
		end)
		button:Show()
		ARP.mlPanel.itemList.prevBtn = button
		table.insert(lootBtnList, {btn = button})
	end
	if (lootBtnList[1]) then ARP.mlPanel.clearLootBtn:Enable()
	else ARP.mlPanel.clearLootBtn:Disable() end
	
	for i,v in pairs(assignBtnList) do v["btn"]:Hide() end
	assignBtnList = {}
	for i=1, #assignList do
		local button = CreateFrame("CheckButton", "AssignButton"..i, ARP.mlPanel.assignList, "UIRadioButtonTemplate")
		button.text = assignList[i]["name"]
		local font = button:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
		font:SetPoint("LEFT", button, "RIGHT", 5, 1)
		button:SetFontString(font)
		button:SetHitRectInsets(0, -225, 0, 0)
		button:SetText(button.text)
		if (i > 1) then	button:SetPoint("TOPLEFT", ARP.mlPanel.assignList.prevBtn, "BOTTOMLEFT", 0, 0)
		else button:SetPoint("TOPLEFT", ARP.mlPanel.assignList, "TOPLEFT", 5, -5) end
		button:SetScript("OnClick", function(self, button, up)
			if (self:GetChecked()) then
				selectedAssign = i
				ARP_MLPanel_SelectAssign(i)
			else selectedAssign = nil end
		end)
		button:Show()
		ARP.mlPanel.assignList.prevBtn = button
		table.insert(assignBtnList, {btn = button})
	end

end

function ARP_MLPanel_AssignLoot()
	SendAddonMessage("ARP_ASSIGN", lootBtnList[selectedItem]["btn"].text, "WHISPER", assignList[selectedAssign]["name"])
	if (lootBtnList[selectedItem]["btn"].count > 1) then 
		SendChatMessage(lootBtnList[selectedItem]["btn"].text.."x"..lootBtnList[selectedItem]["btn"].count.." tells to "..assignList[selectedAssign]["name"], channel)
		SendAddonMessage("ARP_ASSIGN_MULT", lootBtnList[selectedItem]["btn"].count, "WHISPER", assignList[selectedAssign]["name"])
	else SendChatMessage(lootBtnList[selectedItem]["btn"].text.." tells to "..assignList[selectedAssign]["name"], channel) end
	table.remove(lootList, selectedItem)
	table.remove(assignList, selectedAssign)
	selectedItem = nil
	selectedAssign = nil
end

function ARP_MLPanel_ClearLoot()
	while lootList[1] do
		table.remove(lootList, 1)
	end
	bLootListBuilt = false
	selectedItem = nil
	ARP_MLPanel_Update()
end

function ARP_MLPanel_SelectItem(selected)
	for i,v in pairs(lootBtnList) do
		if (i ~= selected) then v["btn"]:SetChecked(false) end
	end
end

function ARP_MLPanel_SelectAssign(selected)
	for i,v in pairs(assignBtnList) do
		if (i ~= selected) then v["btn"]:SetChecked(false) end
	end
end

--------------------)
---Event Handling---)
--------------------)
function ARP_OnEvent(self, event, ...)
	-- Raid Chat (only parsed if an item is currently being bid)
	-- if (event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER") then
		-- if (not bBidding) then return end
		-- local msg, sender = ...
		-- if (not UnitInRaid(sender)) then return end
		-- ARP_HandleChat(msg, sender, "RAID")
	
	-- Guild Chat (only parsed if an item is currently being bid)
	-- elseif (event == "CHAT_MSG_GUILD") then
		-- if (not bBidding) then return end
		-- local msg, sender = ...
		-- if (not UnitInRaid(sender)) then return end
		-- ARP_HandleChat(msg, sender, "GUILD")
		
	-- Whisper
	if (event == "CHAT_MSG_WHISPER") then
		local msg, sender = ...
		if (UnitInRaid(sender)) then ARP_HandleWhisper(msg, sender)
		else return end
		-- ARP_HandleWhisper(msg, sender, "WHISPER")
		
	-- Battle.net Whisper
	elseif (event == "CHAT_MSG_BN_WHISPER") then
		local msg, sender, _, _, _, _, _, _, _, _, _, _, presenceID = ...
		local _, onlineBnetFriends = BNGetNumFriends()
		for i=1, onlineBnetFriends do
			local friendID, _, _, _, toonName, _, client = BNGetFriendInfo(i)
			if (client == BNET_CLIENT_WOW and presenceID == friendID) then
				if (UnitInRaid(toonName)) then ARP_HandleWhisper(msg, toonName) break
				else return end
				-- ARP_HandleWhisper(msg, toonName)
				-- break
			end
		end
		
	-- Addon communication
	elseif (event == "CHAT_MSG_ADDON") then
		local prefix, message, _, sender = ...
		
		-- Add a result to the loot log
		if (prefix == "ARP_LOG") then
			ARP.corePanel.lootLog.text:AddMessage(message)	
		-- Assign an item to a user
		elseif (prefix == "ARP_ASSIGN") then
			item = message			
		-- If assigned item has multiples, send this message too ([Item]x3, etc.)
		elseif (prefix == "ARP_ASSIGN_MULT") then
			itemCount = tonumber(message)
			bMult = true
		elseif (prefix == "ARP_QUERY") then
			if (not item) then SendAddonMessage("ARP_READY", nil, "GUILD") end
		elseif (prefix == "ARP_READY") then
			local found = false
			for i,v in pairs(assignList) do
				if (sender == v["name"]) then found = true end
			end
			if (not found) then table.insert(assignList, {ID = #assignList+1, name = sender}) end
			ARP_MLPanel_Update()
		end
		
	-- If player is the master looter, generate the loot into an assignable list
	elseif ( IsInRaid() and (event == "LOOT_OPENED" and not bLootListBuilt) ) then
		local _, _, mlID = GetLootMethod()
		local mlName = GetRaidRosterInfo(mlID)
		if (mlName == UnitName("player") or bTestMode) then
			local itemIDList = {}
			for i=1, GetNumLootItems() do
				if (GetLootSlotType(i) == 1) then
					local _, itemID = strsplit(":", GetLootSlotLink(i))
					local _, _, rarity = GetItemInfo(itemID)
					if (rarity == 4) then table.insert(itemIDList, itemID) end
					-- table.insert(itemIDList, itemID)
				end
			end
			ARP_BuildItemList(itemIDList)
		end
	end
end

-- function ARP_HandleChat(msg, sender, chnl)
	-- if (chnl ~= channel) then return end	-- Only parse the channel we're bidding through
	-- msg = { strsplit(" ", strlower(msg)) }
	-- if ( strfind(msg[1], "%d+") and strfind(msg[1], "[!@#%$%%%^&%*%(%)-_{}/\<>~`%a+]") ) then
		-- if (sender ~= UnitName("player")) then SendChatMessage("Invalid point amount! Try again.", "WHISPER", nil, sender)
		-- else print("Invalid point amount! Try again.") end
		-- return
	-- end
	-- if ( (msg[1] == "pass" or msg[1] == "yup" or strfind(msg[1], "%d+")) and (item or bTestMode)) then
		-- if (sender == currentBidder) then
			-- local list = ARP_GetList(bidCategory)
			-- if (list[bidderIndex]["points"] < minBid) then ARP_UpdateBid(-1) 
			-- elseif ( msg[1] ~= "pass" and msg[1] ~= "yup" and strfind(msg[1], "%a+") ) then
				-- if (sender ~= UnitName("player")) then SendChatMessage("Invalid point amount! Try again.", "WHISPER", nil, sender)
				-- else print("Invalid point amount! Try again.") end
			-- else 
				-- ARP_UpdateBid(msg[1]) 
			-- end
		-- end
	-- end
-- end

function ARP_HandleWhisper(msg, sender)
	msg = { strsplit(" ", strlower(msg)) }
	local points, spec = "", ""
	if (not bBidding) then 
		if ( (strfind(msg[1], "%a+") and msg[2] == nil) or (strfind(msg[1], "%a+") and strfind(msg[2], "%a+")) ) then return end
		if ( strfind(msg[1], "^%d+$") and (msg[2] == "" or msg[2] == nil or strfind(msg[2], "^%a+$")) ) then
			points = msg[1]
			spec = msg[2]
		elseif ( strfind(msg[1], "^%a+$") and strfind(msg[2], "^%d+$") ) then
			points = msg[2]
			spec = msg[1]
		end
	else points = msg[1]
	end
	if ( points ~= "pass" and (not strfind(points, "^%d+$")) ) then
		if (sender ~= UnitName("player")) then SendChatMessage("Invalid point amount! Please resend tell.", "WHISPER", nil, sender)
		else print("Invalid point amount! Please resend tell.") end
		return
	end
	if ( (points == "pass" or strfind(points, "^%d+$")) and (item or bTestMode) ) then
		if (bBidding) then
			if (sender == currentBidder) then
				local list = ARP_GetList(bidCategory)
				if (list[bidderIndex]["points"] < minBid) then
					if (sender ~= UnitName("player")) then SendChatMessage("You don't have enough points! Forcing pass.", "WHISPER", nil, sender)
					else print("You don't have enough points! Forcing pass.") end
					ARP_UpdateBid(-1)
				elseif ( points ~= "pass" and strfind(points, "%a+") ) then
					if (sender ~= UnitName("player")) then SendChatMessage("Invalid point amount! Please resend tell.", "WHISPER", nil, sender)
					else print("Invalid point amount! Please resend tell.") end
				else
					ARP_UpdateBid(points)
				end
			end
		else
			points = tonumber(points)
			local response
			
			-- Generalize spec
			if (spec == "ms" or spec == "" or spec == nil) then spec = "main"
			elseif (spec == "os") then spec = "off"
			end
			
			if (spec ~= "main" and spec ~= "off") then
				response = "Invalid spec! Please resend tell. Valid options are main/ms or off/os. You can also leave spec blank to default to main spec."
			else
				response = "Tell received! You have ["..points.."] points and are bidding for your ["..spec.."] spec."				
				
				-- Loop through online guild members until the matching sender is found
				-- Once found, retrieve sender's guild rank, then add the sender to the list of bidders
				GuildRoster()
				for i=1, select(2, GetNumGuildMembers()) do
					local charName, _, charRankIndex = GetGuildRosterInfo(i)
					local rank
					if (charName == sender) then
						if (charRankIndex <= rankMember and charRankIndex ~= rankMemberException) then rank = "member"
						elseif (charRankIndex == rankTrial) then rank = "trial"
						end
						
						-- Insert bidders into the appropriate list
						if (rank == "member") then
							if (spec == "main") then ARP_UpdateList(memberMain, sender, points)
							else ARP_UpdateList(memberOff, sender, points) end
						elseif (rank == "trial") then
							if (spec == "main") then ARP_UpdateList(trialMain, sender, points)
							else ARP_UpdateList(trialOff, sender, points) end
						end		
						break
					end
				end
			end
			if (sender ~= UnitName("Player")) then SendChatMessage(response, "WHISPER", nil, sender)
			else print(response) end
		end
	end	
end

-----------------------)
---Bidding Functions---)
-----------------------)
function ARP_BidItem(channel)
	local msg
	if (bMult) then msg = (item.." #"..curNum..": Starting bid! ")
	else msg = (item..": Starting bid! ") end
	local name, response
	
	memberMain = ARP_Sort(memberMain)
	memberOff = ARP_Sort(memberOff)
	
	if (memberMain[1]) then
		name = memberMain[1]["name"]
		minBid = 10
		bidCategory = "mm"
	elseif (memberOff[1]) then
		name = memberOff[1]["name"]
		minBid = 1
		bidCategory = "mo"
	elseif (trialMain[1]) then
		name = trialMain[1]["name"]
		minBid = 10
		bidCategory = "tm"
	elseif (trialOff[1]) then
		name = trialOff[1]["name"]
		minBid = 1
		bidCategory = "to"
	end
	
	SendChatMessage(msg..name.." min "..minBid, channel)
	SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, name)
	currentBidder = name
	bidderIndex = 1
	bBidding = true
end

function ARP_BuildBidString(itemLink)
	local response
	if (itemCount > 1) then response = (itemLink.."x"..itemCount.." ")
	else response = (itemLink.." ") end
		
	memberMain = ARP_Sort(memberMain)
	for i,v in pairs(memberMain) do
		if (i == #memberMain) then response = (response..v["name"].." "..v["points"].." ")
		else response = (response..v["name"].." "..v["points"]..", ") end
	end
	memberOff = ARP_Sort(memberOff)
	for i,v in pairs(memberOff) do
		if (i == 1) then response = (response.."(") end
		if (i == #memberOff) then response = (response..v["name"].." "..v["points"].." OS) ")
		else response = (response..v["name"].." "..v["points"]..", ") end
	end
	trialMain = ARP_Sort(trialMain)
	for i,v in pairs(trialMain) do
		if (i == 1) then response = (response.."(") end
		if (i == #trialMain) then response = (response..v["name"].." "..v["points"].." Trial) ")
		else response = (response..v["name"].." "..v["points"]..", ") end
	end
	trialOff = ARP_Sort(trialOff)
	for i,v in pairs(trialOff) do
		if (i == 1) then response = (response.."(") end
		if (i == #trialOff) then response = (response..v["name"].." "..v["points"].." Trial OS) ")
		else response = (response..v["name"].." "..v["points"]..", ") end
	end
	response = response.." LAST CALL"
	
	return response	
end

function ARP_BuildItemList(itemIDList)
	for i,v in pairs(itemIDList) do
		local found = false
		for x,y in pairs(lootList) do
			if (y["item"] == v) then
				y["count"] = y["count"]+1
				found = true
			end
		end
		if (not found) then table.insert(lootList, {ID = #lootList+1, item = v, count = 1}) end
	end
	
	bLootListBuilt = true
	if (ARP.mlPanel:IsShown()) then ARP_MLPanel_Update() end
end

function ARP_DisplayBidders()
	if (not item and bTestMode) then
		table.insert(lootList, {ID = #lootList+1, item = 90503, count = 2})
		table.insert(lootList, {ID = #lootList+1, item = 87166, count = 1})
		ARP_MLPanel_Update()
	end
	if (item) then
		local response = ARP_BuildBidString(item)
		SendChatMessage(response, channel)
	end
end

function ARP_EndBid(winner, winAmt)
	if (winner == nil) then		-- Everyone passed
		if (bidCategory == "mm") then
			if (memberOff[1]) then
				bidCategory = "mo"
				bidderIndex = 1
				currentBidder = memberOff[1]["name"]
				minBid = 1
				SendChatMessage("Moving to member off specs! "..currentBidder.." min "..minBid, channel)
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			elseif (trialMain[1]) then
				bidCategory = "tm"
				bidderIndex = 1
				currentBidder = trialMain[1]["name"]
				minBid = 10
				SendChatMessage("Moving to trial main specs! "..currentBidder.." min "..minBid, channel)
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			elseif (trialOff[1]) then
				bidCategory = "to"
				bidderIndex = 1
				currentBidder = trialOff[1]["name"]
				minBid = 1
				SendChatMessage("Moving to trial off specs! "..currentBidder.." min "..minBid, channel)
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			else
				if (bMult) then SendChatMessage(item.." #"..curNum..": DE", channel)
				else SendChatMessage(item..": DE", channel) end
				if (itemCount > 1) then
					itemCount = itemCount - 1
					curNum = curNum + 1
					currentBidder = nil
					topBidder = nil
					topBidder = nil
					ARP_StartBid()
				else
					ARP_Reset()
				end
			end
		elseif (bidCategory == "mo") then
			if (trialMain[1]) then
				bidCategory = "tm"
				bidderIndex = 1
				currentBidder = trialMain[1]["name"]
				minBid = 10
				SendChatMessage("Moving to trial main specs! "..currentBidder.." min "..minBid, channel)
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			elseif (trialOff[1]) then
				bidCategory = "to"
				bidderIndex = 1
				currentBidder = trialOff[1]["name"]
				minBid = 1
				SendChatMessage("Moving to trial off specs! "..currentBidder.." min "..minBid, channel)
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			else
				if (bMult) then SendChatMessage(item.." #"..curNum..": DE", channel)
				else SendChatMessage(item..": DE", channel) end
				if (itemCount > 1) then
					itemCount = itemCount - 1
					curNum = curNum + 1
					currentBidder = nil
					topBidder = nil
					topBidder = nil
					ARP_StartBid()
				else
					ARP_Reset()
				end
			end
		elseif (bidCategory == "tm") then
			if (trialOff[1]) then
			bidCategory = "to"
				bidderIndex = 1
				currentBidder = trialOff[1]["name"]
				minBid = 1
				SendChatMessage("Moving to trial off specs! "..currentBidder.." min "..minBid, channel)
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			else
				if (bMult) then SendChatMessage(item.." #"..curNum..": DE", channel)
				else SendChatMessage(item..": DE", channel) end
				if (itemCount > 1) then
					itemCount = itemCount - 1
					curNum = curNum + 1
					currentBidder = nil
					topBidder = nil
					topBidder = nil
					ARP_StartBid()
				else
					ARP_Reset()
				end
			end
		else
			if (bMult) then SendChatMessage(item.." #"..curNum..": DE", channel)
			else SendChatMessage(item..": DE", channel) end
			if (itemCount > 1) then
				itemCount = itemCount - 1
				curNum = curNum + 1
				currentBidder = nil
				topBidder = nil
				topBidder = nil
				ARP_StartBid()
			else
				ARP_Reset()
			end
		end		
	else
		if (bMult) then SendChatMessage(item.." #"..curNum..": "..winner.." for "..winAmt, channel)
		else SendChatMessage(item..": "..winner.." for "..winAmt, channel) end
		local name, _, _, ilvl = GetItemInfo(item)
		local hIndicator = ARP_GetLootIndicator(ilvl)
		SendAddonMessage("ARP_LOG", name..hIndicator.." = "..winner.." "..winAmt, "GUILD")	
		if (itemCount > 1) then
			itemCount = itemCount - 1
			curNum = curNum + 1
			currentBidder = nil
			topBidder = nil
			minBid = nil
			ARP_RemoveWinner(winner)
			ARP_StartBid()
		else 
			ARP_Reset() 
		end
	end
end

function ARP_GetLootIndicator(ilvl)
	for i,v in pairs(heroicLoot) do
		if (ilvl == v) then return " (H)" end
	end
	for i,v in pairs(ilvlLoot) do
		if (ilvl == v) then return " ("..ilvl..")" end
	end
	return ""
end

function ARP_RemoveWinner(winner)
	for i,v in pairs(ARP_GetList()) do
		if (v["name"] == winner) then
			table.remove(ARP_GetList(), i)
			break
		end
	end
end

function ARP_StartBid()
	if (not item) then print ("You have not been assigned an item to bid!")
	else
		if (not memberMain[1] and not memberOff[1] and not trialMain[1] and not trialOff[1]) then
			if (bMult) then 
				if (itemCount == 1) then 
					SendChatMessage(item.." #"..curNum..": DE", channel)
					ARP_Reset() 
					return
				end
				SendChatMessage(item.." #"..curNum..": DE", channel)
				itemCount = itemCount - 1
				curNum = curNum + 1
				ARP_StartBid()
			else 
				SendChatMessage(item..": DE", channel) 
				ARP_Reset()
			end
		else
			ARP_BidItem(channel)
		end
	end
end

function ARP_UpdateBid(bidAmt)
	local list = ARP_GetList(bidCategory)
	local msg = ""
	if (bidAmt == -1) then
		if (bidderIndex == #list) then 
			SendChatMessage(item..": "..currentBidder.." does not have enough points for the minimum! No more bidders.", channel)
			ARP_EndBid(topBidder, minBid-1)
		else
			bidderIndex = bidderIndex + 1
			for i=bidderIndex, #list do
				if (i == #list) then msg = (msg..list[i]["name"])
				else msg = (msg..list[i]["name"]..", ") end
			end
			msg = (item..": "..currentBidder.." does not have enough points for the minimum! Remaining bidders: "..msg)
			SendChatMessage(msg, channel)
			currentBidder = list[bidderIndex]["name"]
		end
	elseif (bidAmt == "pass") then
		if (bidderIndex == #list) then
			SendChatMessage(item..": "..currentBidder.." has passed! No more bidders.", channel)
			ARP_EndBid(topBidder, minBid-1)
		else
			bidderIndex = bidderIndex + 1			
			for i=bidderIndex, #list do
				if (i == #list) then msg = (msg..list[i]["name"])
				else msg = (msg..list[i]["name"]..", ") end
			end
			msg = (item..": "..currentBidder.." has passed! Top bidder: "..topBidder.."; Remaining bidders: "..msg)
			SendChatMessage(msg, channel)
			currentBidder = list[bidderIndex]["name"]
		end
	else
		if (string.sub(bidAmt, 1, 1) == "+") then bidAmt = ((minBid-1) + tonumber(bidAmt))
		elseif (bidAmt == "yup") then bidAmt = minBid
		else bidAmt = tonumber(bidAmt) end
		if (bidAmt < minBid) then
			SendChatMessage("Your bid is too low! The minimum is "..minBid, "WHISPER", nil, currentBidder)
		elseif (bidAmt > list[bidderIndex]["points"]) then
			SendChatMessage("You don't have that many points! You have "..list[bidderIndex]["points"], "WHISPER", nil, currentBidder)
		else
			topBidder = currentBidder
			if (bidderIndex == #list) then
				if (bidAmt > minBid) then bidAmt = minBid end
				SendChatMessage(item..": "..currentBidder.." has bid "..bidAmt..". No more bidders!", channel)
				ARP_EndBid(topBidder, bidAmt)
			else
				minBid = bidAmt + 1
				bidderIndex = bidderIndex + 1
				for i=bidderIndex, #list do
					if (i == #list) then msg = (msg..list[i]["name"])
					else msg = (msg..list[i]["name"]..", ") end
				end
				msg = (item..": "..currentBidder.." has bid "..bidAmt..". Remaining bidders: "..msg)
				SendChatMessage(msg, channel)
				currentBidder = list[bidderIndex]["name"]
				SendChatMessage("It is your bid! Min "..minBid, "WHISPER", nil, currentBidder)
			end
		end
	end
end

function ARP_UpdateList(list, name, points)
	local found = false
	for i,v in ipairs(list) do
		if (v["name"] == name) then
			v["points"] = points
			found = true
			break
		end
	end
	if (not found) then 
		table.insert(list, {ID = #list+1, name = name, points = points})
	end	
end

--------------------)
---Misc Functions---)
--------------------)
function ARP_GetList()
	if (bidCategory == "mm") then return memberMain
	elseif (bidCategory == "mo") then return memberOff
	elseif (bidCategory == "tm") then return trialMain
	elseif (bidCategory == "to") then return trialOff
	end
end

function ARP_Reset()
	memberMain = {}
	memberOff = {}
	trialMain = {}
	trialOff = {}
	
	currentBidder = nil
	bidderIndex = nil
	topBidder = nil
	item = nil
	itemCount = 1
	curNum = 1
	
	bBidding = false
	bLootListBuilt = false
	bMult = false
	SendAddonMessage("ARP_READY", nil, "GUILD")
	ARP_MLPanel_Update()
end

function ARP_Sort(list)
	table.sort(list, function(a, b)
		return a["points"] < b["points"]
	end)
	return list
end
